;By Barry Kauler 2000, http://www.goosee.com/
;SKELETON.ASM --> SKELETON.EXE
;Win32 application written for masm 6.14

.386
.387
.MODEL FLAT,STDCALL
      option casemap :none   ; case sensitive
UNICODE = 0
INCLUDE WIN32ML.INC

INCLUDE SKELETON.INC


;---------------------------------------------------------------------------
.DATA
  BYTE 32 DUP(?)

hInst        DWORD 0
mainhwnd     DWORD 0
s1           WNDCLASS <?>
s2           MSG <?>
s3           PAINTSTRUCT <?>
szTitleName  BYTE "Win32 Assembly Language Demo Program",0
szClassName  BYTE "SKELETON",0
sziconname   BYTE "ICON_1",0	    ;name of icon in .RC file.

g_hwnd       DWORD 0	;handle for main window.

szaboutstr   BYTE "Skeleton 32-bit Windows application",0Dh,0Ah
             BYTE "by Barry Kauler",0Dh,0Ah
             BYTE "http://www.goosee.com/",0
sztitlestr   BYTE "Goosee Systems demo application",0


;---------------------------------------------------------------------------
.CODE
start:

  invoke  GetModuleHandle, NULL
  mov hInst,eax

;initialize the WndClass structure
  mov s1.w_style,CS_HREDRAW+CS_VREDRAW+CS_DBLCLKS
  mov s1.w_lpfnWndProc,OFFSET ASMWNDPROC
  mov s1.w_cbClsExtra,0
  mov s1.w_cbWndExtra,0

  mov eax,hInst
  mov s1.w_hInstance,eax

;  call LoadIcon, NULL,IDI_APPLICATION	  ;loads default icon.
;let's load a custom icon....
  invoke LoadIcon, hInst,ADDR sziconname
  mov s1.w_hIcon,eax

  invoke LoadCursor,NULL,IDC_ARROW
  mov s1.w_hCursor,eax

  mov s1.w_hbrBackground,COLOR_WINDOW+1
  mov s1.w_lpszMenuName,OFFSET szClassName
  mov s1.w_lpszClassName,OFFSET szClassName

  invoke RegisterClass, ADDR s1
  test eax,eax
  jz end_loop  ;exit if eax=0.

  invoke CreateWindowEx, 0,ADDR szClassName,ADDR szTitleName, \
	WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT, \
	CW_USEDEFAULT,CW_USEDEFAULT, 0, 0, hInst, 0
  test eax,eax
  jz end_loop	    ;exit if eax=0.
  mov mainhwnd,eax

  invoke ShowWindow, mainhwnd,SW_SHOWNORMAL
  invoke UpdateWindow, mainhwnd

msg_loop:
  invoke GetMessage, ADDR s2,0,0,0
  cmp ax,0
  je end_loop
  invoke TranslateMessage, ADDR s2
  invoke DispatchMessage, ADDR s2
  jmp msg_loop

end_loop:
  invoke ExitProcess, s2.ms_wParam

;-----------------------------------------------------------------------------
    PUBLIC ASMWNDPROC
ASMWNDPROC PROC USES ebx edi esi,hwnd:DWORD,wmsg:DWORD,wparam:DWORD,lparam:DWORD

  mov eax,hwnd	    ;useful to make this static.
  mov g_hwnd,eax

	xor eax,eax
        mov ax,WORD PTR wmsg
	.IF ax==WM_DESTROY
	  invoke wmdestroy, wmsg,wparam,lparam
	.ELSEIF ax==WM_RBUTTONDOWN
	  invoke wmrbuttondown, wmsg,wparam,lparam
	.ELSEIF ax==WM_SIZE
	  invoke wmsize, wmsg,wparam,lparam
	.ELSEIF ax==WM_CREATE
	  invoke wmcreate, wmsg,wparam,lparam
	.ELSEIF ax==WM_LBUTTONDOWN
	  invoke wmlbuttondown, wmsg,wparam,lparam
	.ELSEIF ax==WM_PAINT
	  invoke wmpaint, wmsg,wparam,lparam
	.ELSEIF ax==WM_COMMAND
	  invoke wmcommand, wmsg,wparam,lparam
	.ELSE
	  invoke DefWindowProc, hwnd,wmsg,wparam,lparam
	  ret
	.ENDIF
	xor eax,eax
	ret
ASMWNDPROC ENDP
;-----------------------------------------------------------------------------
wmcommand PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	mov ax,WORD PTR lparam
	.IF ax==0
	  mov ax,WORD PTR wparam
	  .IF ax==IDM_QUIT
	    invoke DestroyWindow, g_hwnd	  ;exit GOOSEE
	    ;NOTE this will post WM_DESTROY msg, which calls wmdestroy()
	    ;which closes things down and posts PostQuitMessage().
	  .ELSEIF ax==IDM_ABOUT
	    invoke MessageBox, g_hwnd,ADDR szaboutstr,ADDR sztitlestr, MB_OK
	  .ENDIF
	.ENDIF
    ret
wmcommand ENDP

;------------------------------------------------------------------------
wmpaint PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
	LOCAL hdc:DWORD
    invoke BeginPaint, g_hwnd,ADDR s3
        mov hdc,eax

        invoke TextOut, hdc,100,100,ADDR sztitlestr,31

    invoke EndPaint, g_hwnd,ADDR s3
    ret
wmpaint ENDP

;------------------------------------------------------------------------
wmcreate PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    ret
wmcreate ENDP

;------------------------------------------------------------------------
wmdestroy PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    invoke PostQuitMessage,0
    ret
wmdestroy ENDP

;------------------------------------------------------------------------
wmlbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    ret
wmlbuttondown ENDP

;------------------------------------------------------------------------
wmrbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    invoke MessageBeep,0
    ret
wmrbuttondown ENDP

;------------------------------------------------------------------------
wmsize PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
    ret
wmsize ENDP

;------------------------------------------------------------------------
end start
